<?php

namespace app\controllers\mikrotik\ppp;

use yii\helpers\Url;
use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\filters\VerbFilter;
use app\models\mikrotik\MikrotikSideMenu;
use app\models\mikrotik\ppp\Servers;

class ServersController extends Controller {

    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'except' => ['index'],
                'rules' => [
                 [
                        'actions' => ['create'],
                        'allow' => true,
                        'roles' => ['mikrotik_pppCreateServers'],
                    ],
                    [
                        'actions' => ['delete'],
                        'allow' => true,
                        'roles' => ['mikrotik_pppDeleteServers'],
                    ],
                    [
                        'actions' => ['disable'],
                        'allow' => true,
                        'roles' => ['mikrotik_pppDisableServers'],
                    ],
                    [
                        'actions' => ['enable'],
                        'allow' => true,
                        'roles' => ['mikrotik_pppEnableServers'],
                    ],
                     [
                        'actions' => ['update'],
                        'allow' => true,
                        'roles' => ['mikrotik_pppUpdateServers'],
                    ],
                    [
                        'actions' => [],
                        'allow' => true,
                        'roles' => ['admin'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    public function actionUpdate() {
        $id = Yii::$app->request->get('id');
        $menu = new MikrotikSideMenu();
        $model = new Servers();

        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            if ($_POST['Servers']['authentication'] != '') {
                $opt = implode(",", $_POST['Servers']['authentication']);
                $model->authentication = $opt;
            }
            $c = $model->update($id);
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/ppp/ppp/index'));
            }
        } else {
            $model->get($id);
        }
        $model->authentication = explode(',', $model->authentication);
        return $this->render('/mikrotik/ppp/servers', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'update',
                    'interface' => $model->getInterfaces(),
                    'profile' => $model->getProfiles(),
        ]);
    }

    public function actionCreate() {
        $menu = new MikrotikSideMenu();
        $model = new Servers();

        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            if ($_POST['Servers']['authentication'] != '') {
                $opt = implode(",", $_POST['Servers']['authentication']);
                $model->authentication = $opt;
            }
            $c = $model->create();
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/ppp/ppp/index'));
            }
        }

        return $this->render('/mikrotik/ppp/servers', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'create',
                    'interface' => $model->getInterfaces(),
                    'profile' => $model->getProfiles(),
        ]);
    }

    public function actionDisable() {
        $id = Yii::$app->request->get('id');
        $model = new Servers();
        $model->disable($id);
        return $this->redirect(Url::toRoute('mikrotik/ppp/ppp/index'));
    }

    public function actionDelete() {
        $id = Yii::$app->request->get('id');
        $model = new Servers();
        $model->delete($id);
        return $this->redirect(Url::toRoute('mikrotik/ppp/ppp/index'));
    }

    public function actionEnable() {
        $id = Yii::$app->request->get('id');
        $model = new Servers();
        $model->enable($id);
        return $this->redirect(Url::toRoute('mikrotik/ppp/ppp/index'));
    }

}
